/*
ADC    AT90S8535

 AVR " "    -  5

avr123.by.ru 

CodeVisionAVR C Compiler

   AREF = 5.0V
  3.69 
     PA0
 ( !)   PORTB
  0_4  PORTB  .
*/

#include <90s8535.h>   /*    ""  AT90S8535.              */

#include <delay.h> //   

#define ADC_VREF_TYPE 0x00 /*        "ADC_VREF_TYPE"  "0x00"   #define      -    ! */

/*          .

      - : */

interrupt [ADC_INT] void adc_isr(void) {
/*  !             -             */

PORTB=(unsigned char) ~ADCW;
/*   PORTB  . 

   ! 

 ADCW     DataSheet         -   16  ,    10   - ,       DataSheet,  : ADCL  ADCH  

   ~   -  :     ,     ,  "1"    -           "0" */

delay_ms(20);  //  20  

ADCSR|=0x40; //   
//  .
//  DataSheet   ADCSR !

} //   - 
//  


////////////////////////////////////////


void main(void) {  /*   main -         */

PORTB=0xFF; /*  PORTB -    */
DDRB=0xFF; /*    PORTB  "1" -    */

ADCSR=0x8E; /*  .63 DataSheet   ADCSR    ,    . 

,    ADCSR  0x8E 
 1000 1110 

Bit 7 - ADEN:  1 -   

Bit 6 - ADSC: 1 -  ,    '0'     .

Bit 5 - ADFR: 1 -      .   Bit 5 = '0' 

Bit 4 -ADIF:   -     1      ,      ! 

Bit 3 - ADIE: 1 -     .

Bits 2..0 - ADPS2..ADPS0:     -   110 -  .  64 -    57,65625 . */

#asm("sei") //    
//  !


ADMUX=0; //  ,   
//   . 
//  DataSheet   ADMUX 
//       


ADCSR|=0x40; /*     '1' _6   ADCSR  

   ? 

      "1"       -    "" (    | )      ,  "1"     . 

        ,    "0"  ? */

while (1); /*   -        ,              */

} //    main



