//ICC-AVR application builder : 11.03.2002 20:01:52
// Target : 2313
// Crystal: 3.6864Mhz
//      6  
//     rs232   3 
//      
//    ( / 3.6864)  

#include <io2313v.h>
#include <macros.h>

# define max_count 315 
//    -   
//   2   
// 


//////////////////////////
///  

unsigned int	 result; //   -  
char low_result; //   
char hi_result;  //   
unsigned int	 temp;  //   
char no_INT0=1;  // INT0   
unsigned int	 counter; //  
char dig_out; //     rs232



//////////////////////////
///   

void port_init(void);
void timer0_init(void);
void timer0_ovf_isr(void);
void uart0_init(void);
void int0_isr(void);
void init_devices(void);


void get_period(void);
void send_result(void);
void save_result(void);


//////////////////////////




void main(void)
{
 init_devices();
 
 while(1);
 
}



////////////////////////////////////////////////



void get_period(void)
{

counter = 0;

CLI(); //   

//    INT0
//  "1"  _6 . GIFR
GIFR |= 0x40; // turn on bit6 

//     INT0
GIMSK = 0x40;

SEI(); //  



//while(no_INT0); //   
//   


//    
//     

while((no_INT0) && (counter < max_count))
{
counter ++; //   1
}

// !!!   "counter" !!!

if (!(counter < max_count))
   goto low_freq;  //   

//  ,   
// Taimer1   
//

no_INT0 = 1;
//    INT0

GIFR |= 0x40; //   INT0



counter = 0;


//    
//     

while((no_INT0) && (counter < max_count))
{
counter ++; //   1
}

// !!!   "counter" !!!

//      INT0
//      
//     
//  max_count

low_freq: 

CLI(); //   

// .  INT0
GIMSK = 0x00; //  =0;

SEI(); //  



no_INT0 = 1;
//    INT0

//      
//     
//    1 
TCCR1B = 0x00;

//    

low_result = TCNT1L; //   
 hi_result = TCNT1H; //   
 

 /////////////////////    ///////////////////////
 // putchar(0x0D);
 // putchar(hi_result);
 // putchar(low_result);
 /////////////////////    ///////////////////////
 
 

//     
TCNT1H = 0x00; 
TCNT1L = 0x00; 

}





//////////////////////////////////////////////////

void send_result(void)
{
//    500 
  if (counter < max_count)
    {

//    2- 

result = 0; //  

result += hi_result; //   

result <<= 8; //    
// 8    -    

result += low_result; //   

//  result   

//      :

dig_out=0; //     rs232





while (result >= 1000)
{
  result -= 1000; //   1000

  dig_out ++; //  
}

putchar(0x0D);
//    

putchar(dig_out + 48);
//   ""

dig_out = 0; // 

while (result >= 100)
{
  result -= 100; //   100

  dig_out ++; //  
}

putchar(dig_out + 48);
//   ""

dig_out = 0; // 

while (result >= 10)
{
  result -= 10; //   10

  dig_out ++; //  
}

putchar(dig_out + 48);
//   ""

dig_out = 0; // 

while (result >= 1)
{
  result -= 1; //   1

  dig_out ++; //  
}

putchar(dig_out + 48);
//   ""

   }

 
//    500 
  if (!(counter < max_count))
    {

//    "NO-F"   

putchar(0x0D);
//    

putchar('N');
putchar('O');
putchar('-');
putchar('F');
//  

    }

}





/////////////////////////////////////////////////

void save_result(void)
{

}




//////////////////////////////////////////////////////////////

void port_init(void)
{
 PORTB = 0xFF;
 DDRB  = 0x07; 
 PORTD = 0x7F;
 DDRD  = 0x00; 
}



//////////////////////////////////////////////////////////////

//TIMER0 initialisation - prescale:1024
// desired value: 50Hz
// actual value: 50,000Hz (0,0%)
void timer0_init(void)
{
 TCCR0 = 0x00; //stop timer
 TCNT0 = 0xB8; //set count
 TCCR0 = 0x05; //start timer
}





/////////////////////////////////////////////////

#pragma interrupt_handler timer0_ovf_isr:7

void timer0_ovf_isr(void)
{
 //TIMER0   255  0
 TCNT0 = 0xB8; 
 //     184
 
 
 //..   20   
 
 
 //  -     
 // PORTB ^= 0x01;  ///  PB0
 
get_period();  
//.. 

 /////////////////////    ///////////////////////
 // PORTB ^= 0x01;  ///  PB0
 

 send_result();  
//..   rs232 

 
 
 save_result();
//..    


 result=0; 
//  

}




/////////////////////////////////////////////////





//UART0 initialisation
// desired baud rate: 9600
// actual: baud rate:9600 (0,0%)
void uart0_init(void)
{
 UCR  = 0x00; //disable while setting baud rate
 UBRR = 0x17; //set baud rate
 UCR  = 0x08; //enable
}




////////////////////////////////////////////////





#pragma interrupt_handler int0_isr:2
void int0_isr(void)
{
//  _1  TCCR1B
TCCR1B^=0x01;
//  1  -   
//  1  -   

//   INT0  !



 /////////////////////    ///////////////////////
 PORTB ^= 0x02;  ///  PB1
 
 

no_INT0 = 0;
//   "no_INT0"
}





///////////////////////////////////////////////////////





//call this routine to initialise all peripherals

void init_devices(void)
{
//    
//   
CLI(); //   

port_init();
timer0_init();
uart0_init();

TCCR1B = 0x00; 
//  1

TCNT1H = 0x00; 
TCNT1L = 0x00; 
//     ...
//     

TCCR1A = 0x00;

//    1 
//     

MCUCR = 0x02;

GIMSK = 0x00; // INT0 
              // 0x40 - 
TIMSK = 0x02;

SEI(); //  

}
